<div class="tabla-productos">
  <p-toolbar styleClass="mb-2">
    <div class="flex gap-3">
      <button class="btn btn-primary-1" (click)="openDialogCrearProducto()">
        <i class="uil uil-plus"></i>
        Nuevo producto
      </button>

      <button *ngIf="estadoSeleccionado === 1" class="btn btn-secondary-1" (click)="dialogConfirmacion('MP')"
        [disabled]="!productosSeleccionados"
        [ngClass]="{'btn-disabled': productosSeleccionados.length > 0 ? false : true}">
        <i class="uil uil-trash-alt"></i>
        Eliminar
      </button>

      <button *ngIf="estadoSeleccionado === 0" class="btn btn-secondary-1" (click)="dialogConfirmacion('HP')"
        [disabled]="!productosSeleccionados"
        [ngClass]="{'btn-disabled': productosSeleccionados.length > 0 ? false : true}">
        <i class="uil uil-check"></i>
        Habilitar
      </button>
    </div>

    <div class="p-toolbar-group-end">
      <p-dropdown [options]="estados" [(ngModel)]="estadoSeleccionado" optionLabel="nombre" optionValue="value"
        class="inpt_secon" (onChange)="cargarDatosProductos()"></p-dropdown>
    </div>
  </p-toolbar>

  <ng-template #mensaje>
    <div class="mensaje">
      <p>No se encontraron productos en este momento. ¿Tienes un producto que quisieras agregar? ¡Regístralo ahora!</p>
    </div>
  </ng-template>

  <ng-container *ngIf="productos.length > 0 else mensaje">
    <p-table #dt [value]="productos" [rows]="10" [paginator]="true"
      [globalFilterFields]="['codigo', 'nombre', 'precioVenta', 'stockTotal', 'stockRestante', 'categoriaProducto.nombre']"
      [tableStyle]="{ 'min-width': '90rem' }" [(selection)]="productosSeleccionados" [rowHover]="true"
      dataKey="idProducto" currentPageReportTemplate="Mostrando del {first} al {last} de {totalRecords} resultados"
      [showCurrentPageReport]="true">
      <ng-template pTemplate="caption">
        <div class="buscador">
          <span class="span-buscador">
            <i class="pi pi-search"></i>
            <input class="inpt_secon" type="text" placeholder="Buscar..." (input)="busqueda($event)" />
          </span>
        </div>
      </ng-template>

      <ng-template pTemplate="header">
        <tr>
          <th style="width: 4rem">
            <p-tableHeaderCheckbox></p-tableHeaderCheckbox>
          </th>
          <th pSortableColumn="codigo" style="min-width:auto">Codigo<p-sortIcon field="codigo"></p-sortIcon></th>
          <th pSortableColumn="nombre" style="min-width:auto">Nombre<p-sortIcon field="nombre"></p-sortIcon></th>
          <th>Imagen</th>
          <th pSortableColumn="precioVenta">Precio<p-sortIcon field="precioVenta"></p-sortIcon></th>
          <th pSortableColumn="stockTotal" style="min-width:auto">Stock<p-sortIcon field="stock"></p-sortIcon></th>
          <th pSortableColumn="stockRestante" style="min-width:auto">Stock Restante<p-sortIcon field="stockRestante"></p-sortIcon></th>
          <th pSortableColumn="categoriaProducto.nombre">Categoria<p-sortIcon field="categoria"></p-sortIcon></th>
          <th pSortableColumn="estado">Estado<p-sortIcon field="estado"></p-sortIcon></th>
          <th></th>
        </tr>
      </ng-template>

      <ng-template pTemplate="body" let-producto>
        <tr>
          <td>
            <p-tableCheckbox [value]="producto"></p-tableCheckbox>
          </td>
          <td>
            <span *ngIf="producto.codigo">{{ producto.codigo }}</span>
            <span *ngIf="!producto.codigo">-</span>
          </td>
          <td>{{ producto.nombre }}</td>
          <td>
            <figure style="width: 60px; height: 60px;">
              <p-image [src]="producto.ImagenesProducto[0].ImgUrl" [preview]="true" alt="Foto del producto"
                [style]="{ 'object-fit': 'cover' }"></p-image>
            </figure>
          </td>
          <td>{{ producto.precioVenta | currency: 'Bs ' }}</td>
          <td> {{ producto.stockTotal }} </td>
          <td> {{ producto.stockRestante }} </td>
          <td>{{ producto.categoriaProducto.nombre }}</td>
          <td>
            <span *ngIf="producto.estado === '1'" class="producto_activo">ACTIVO</span>
            <span *ngIf="producto.estado === '0'" class="producto_inactivo">INACTIVO</span>
          </td>
          <td class="botones-td">
            <button pButton icon="pi pi-pencil" class="p-button-rounded btn"
              (click)="openDialogEditarProducto(producto)"></button>

            <button pButton icon="uil uil-image-edit" class="p-button-rounded btn"
              (click)="abrirDialogEdicionImagen(producto)"></button>

            <button *ngIf="estadoSeleccionado === 1" pButton icon="pi pi-trash" class="p-button-rounded btn"
              (click)="dialogConfirmacion('UP', producto)"></button>

            <button *ngIf="estadoSeleccionado === 0" pButton icon="pi pi-check" class="p-button-rounded btn"
              (click)="dialogConfirmacion('AP', producto)" pTooltip="Habilitar producto"
              tooltipPosition="left"></button>
          </td>
        </tr>
      </ng-template>
      <ng-template pTemplate="summary">
        <span>En total hay {{ productos.length }} productos.</span>
      </ng-template>
    </p-table>
  </ng-container>
</div>

<!-- Dialog para crear o editar un producto -->
<div class="dialog-container-general">
  <p-dialog [(visible)]="productDialog" [style]="{ width: '470px'}" header="Detalles del producto"
    [modal]="true" (onHide)="limpiarProducto()">
    <ng-template pTemplate="content">
      <p-tabView (onChange)="onTabChange($event)">
        <p-tabPanel header="Datos del producto">
          <div class="datoProducto">
            <div *ngIf="!isProductoEdit" class="grid-field">
              <figure>
                <p-image src="{{ imgUrl }}" [preview]="true" alt="Foto del producto"></p-image>
              </figure>

              <p-fileUpload #fileUpload [customUpload]="true" [style]="{float: 'right'}" chooseLabel="Subir foto"
                (uploadHandler)="obtenerImagen($event)" mode="basic" accept="image/*" [maxFileSize]="1000000"
                [auto]="true" pTooltip="Agregar foto del producto">
              </p-fileUpload>
            </div>

            <div class="field">
              <label for="nombre">Nombre</label>
              <input type="text" class="inpt_secon" id="name" placeholder="Nombre del producto"
                [(ngModel)]="producto.Nombre" required autofocus (keyup)="validarTexto($event, 'Nombre')" />
            </div>

            <div class="field">
              <label for="descripcion">Descripción</label>
              <textarea id="description" pInputTextarea class="inpt_secon text-area" placeholder="Descripción"
                [(ngModel)]="producto.Descripcion" required rows="3" cols="20"
                (keyup)="validarTexto($event, 'Descripcion')"></textarea>
            </div>

            <div class="grid-field">
              <div class="field">
                <label for="codigo">Código</label>
                <input type="text" class="inpt_secon" id="codigo" placeholder="Código del producto"
                  [(ngModel)]="producto.Codigo" required autofocus (keyup)="validarCodigo()" (keyup)="validarTexto($event, 'Codigo')" />

                <div *ngIf="mostrarTag">
                  <p-tag severity="danger" value="El código ya está en uso. Por favor, elige otro."
                    [ngClass]="existeCodigo ? 'tag_codigo_existe' : 'ocultar'"></p-tag>
                  <p-tag severity="success" value="Código disponible."
                    [ngClass]="existeCodigo ? 'ocultar' : 'tag_codigo_noexiste'"></p-tag>
                </div>
              </div>

              <div class="field">
                <label for="stock">Stock Total</label>
                <p-inputNumber id="stock" class="inpt_secon bordernone" placeholder="Stock"
                  [(ngModel)]="producto.StockTotal"></p-inputNumber>
              </div>
            </div>

            <div class="grid-field">
              <div class="field">
                <label for="stockMinimo">Stock Mínimo</label>
                <p-inputNumber id="stockMinimo" class="inpt_secon bordernone" placeholder="Stock"
                  [(ngModel)]="producto.StockMinimo"></p-inputNumber>
              </div>

              <div class="field">
                <p class="p_txt">
                  <i class="uil uil-question-circle"></i>
                  El stock mínimo sirve para que el sistema te avise cuando el stock del producto esté por debajo de
                  este
                  valor.
                </p>
              </div>

            </div>

            <div class="grid-field">
              <div class="field">
                <label for="precioCosto">Precio Costo Bs.</label>
                <p-inputNumber id="precioCosto" [(ngModel)]="producto.PrecioCosto" placeholder="Precio costo"
                  mode="currency" currency="BOB" locale="es-ES"></p-inputNumber>
              </div>

              <div class="field">
                <label for="precioVenta">Precio Venta Bs.</label>
                <p-inputNumber id="precioVenta" [(ngModel)]="producto.PrecioVenta" placeholder="Precio de venta"
                  mode="currency" currency="BOB" locale="es-ES"></p-inputNumber>
              </div>
            </div>

            <div class="field">
              <label>Categoria</label>
              <p-dropdown [options]="categoriasProducto" class="inpt_secon"
                [(ngModel)]="producto.CategoriaProducto.IdCategoria" optionLabel="Nombre" optionValue="IdCategoria"
                placeholder="Selecciona una categoría">
              </p-dropdown>
            </div>
          </div>
        </p-tabPanel>
        <!-- Formulario para la facturación del producto -->
        <p-tabPanel header="Facturación Electrónica">
          <div class="datosFacturacion">
            <p><i class="uil uil-info-circle"></i> NOTA: Estos datos son usados para generar la factura correspondiente.
            </p>
            <label class="font-semibold uppercase mb-3">Homologación de productos</label>
            <div class="flex flex-column mb-3">
              <label for="unidadSIN">Unidad de medida del SIN</label>
              <p-dropdown [options]="unidadMedidaSIN" class="inpt_secon unidad_SIN"
                [(ngModel)]="producto.CodigoUnidadSIN" optionLabel="nombre" optionValue="value"
                placeholder="Selecciona una unidad">
              </p-dropdown>
            </div>

            <div class="flex flex-column">
              <label for="productoSIN">Producto del SIN</label>
              <p-dropdown [options]="codigoProductoSIN" class="inpt_secon producto_SIN"
                [(ngModel)]="producto.CodigoProductoSIN" optionLabel="nombre" optionValue="value"
                placeholder="Selecciona un producto">
              </p-dropdown>
            </div>
          </div>
        </p-tabPanel>
      </p-tabView>
    </ng-template>

    <ng-template pTemplate="footer">
      <button pButton label="Cancelar" icon="pi pi-times" class="btn btn-primary-1"
        (click)="productDialog = false;"></button>

      <button *ngIf="!isProductoEdit" pButton label="Guardar" icon="pi pi-check" class="btn btn-secondary-1"
        (click)="guardarProductoNuevo()"></button>

      <button *ngIf="isProductoEdit" pButton label="Actualizar" icon="pi pi-check" class="btn btn-secondary-1"
        (click)="dialogConfirmacion('EP')"></button>
    </ng-template>
  </p-dialog>
</div>

<!-- Dialog para la edición de las imagenes del producto -->
<div class="dialog-container-general" *ngIf="listaImagenes.length">
  <p-dialog header="Fotos del producto" [modal]="true" [(visible)]="dialogImagenVisible"
    [style]="{ width: '35vw', height: '600px' }">

    <div class="formulario imagenesCrud">
      <p-orderList [value]="listaImagenes" [listStyle]="{ 'max-height': '20rem', 'height': '20rem' }" header="Products"
        headerTemplate="header" [dragdrop]="true" (onReorder)="actualizarListaImagenes()">
        <ng-template pTemplate="header">
          <div class="header-container">
            <label class="label-fw700">Fotos del producto</label>

            <div *ngIf="listaImagenes.length < 4">
              <p-fileUpload #fileUpload [customUpload]="true" (uploadHandler)="agregarImagen($event, fileUpload)"
                mode="basic" accept="image/*" [maxFileSize]="1000000" [auto]="true" pTooltip="Agregar nueva foto">
              </p-fileUpload>
            </div>
          </div>
        </ng-template>

        <ng-template let-imagen pTemplate="item">
          <div class="contenedor-imagen">
            <figure>
              <p-image src="{{ imagen.imgUrl }}" [preview]="true" alt="Foto del producto"></p-image>
            </figure>

            <label class="label-fw700 {{ imagen.principal ? 'principal' : 'secundario' }}">{{ imagen.principal ?
              'Principal' : 'Secundario' }}</label>

            <button *ngIf="listaImagenes.length > 1" class="btn btn-secondary-1" (click)="eliminarImagen(imagen)"><i
                class="uil uil-trash-alt"></i></button>
          </div>
        </ng-template>
      </p-orderList>

      <button class="btn btn-primary-2" [disabled]="estaInhabilitado" [ngClass]="{'btn-disabled': estaInhabilitado}"
        (click)="dialogConfirmacion('EI')"> Guardar cambios </button>
    </div>
  </p-dialog>
</div>

<p-confirmDialog [style]="{width: '30vw'}" key="dialogEditProducto">
  <ng-template pTemplate="header">
    <h3>{{ tituloDialogConfirmacion }}</h3>
  </ng-template>
  <ng-template pTemplate="footer">
    <button class="btn btn-primary-1" (click)="cancelar()">CANCELAR</button>
    <button class="btn btn-secondary-1" (click)="guardarCambios(operacion)">CONFIRMAR</button>
  </ng-template>
</p-confirmDialog>

<app-loading-overlay *ngIf="mostrarSpinner" [mensaje]="mensajeSpinner"></app-loading-overlay>
